Module javafx.graphics
Package javafx.scene.shape

# Class Arc

java.lang.Object
javafx.scene.Node
javafx.scene.shape.Shape
javafx.scene.shape.Arc

All Implemented Interfaces:
  `Styleable`, `EventTarget`

public class Arc extends Shape
The `Arc` class represents a 2D arc object, defined by a center point, start angle (in degrees), angular extent (length of the arc in degrees), and an arc type (`ArcType.OPEN`, `ArcType.CHORD`, or `ArcType.ROUND`).

Example usage: the following code creates an Arc which is centered around 50,50, has a radius of 25 and extends from the angle 45 to the angle 315 (270 degrees long), and is round.

    import javafx.scene.shape.*;

    Arc arc = new Arc();
    arc.setCenterX(50.0f);
    arc.setCenterY(50.0f);
    arc.setRadiusX(25.0f);
    arc.setRadiusY(25.0f);
    arc.setStartAngle(45.0f);
    arc.setLength(270.0f);
    arc.setType(ArcType.ROUND);

Since:
  JavaFX 2.0

- ## Property Summary

  Properties
  Type
  Property
  Description
  `final DoubleProperty`
  `centerX`
  Defines the X coordinate of the center point of the arc.
  `final DoubleProperty`
  `centerY`
  Defines the Y coordinate of the center point of the arc.
  `final DoubleProperty`
  `length`
  Defines the angular extent of the arc in degrees.
  `final DoubleProperty`
  `radiusX`
  Defines the overall width (horizontal radius) of the full ellipse of which this arc is a partial section.
  `final DoubleProperty`
  `radiusY`
  Defines the overall height (vertical radius) of the full ellipse of which this arc is a partial section.
  `final DoubleProperty`
  `startAngle`
  Defines the starting angle of the arc in degrees.
  `final ObjectProperty<ArcType>`
  `type`
  Defines the closure type for the arc: `ArcType.OPEN`, `ArcType.CHORD`,or `ArcType.ROUND`.

  ### Properties declared in class javafx.scene.shape.Shape

  `fill, smooth, strokeDashOffset, strokeLineCap, strokeLineJoin, strokeMiterLimit, stroke, strokeType, strokeWidth`

  ### Properties declared in class javafx.scene.Node

  `accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, focusVisible, focusWithin, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

- ## Field Summary

  ### Fields declared in class javafx.scene.Node

  `BASELINE_OFFSET_SAME_AS_HEIGHT`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Arc()`
  Creates an empty instance of Arc.
  `Arc(double centerX, double centerY, double radiusX, double radiusY, double startAngle, double length)`
  Creates a new instance of Arc.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final DoubleProperty`
  `centerXProperty()`
  Defines the X coordinate of the center point of the arc.
  `final DoubleProperty`
  `centerYProperty()`
  Defines the Y coordinate of the center point of the arc.
  `final double`
  `getCenterX()`
  Gets the value of the `centerX` property.
  `final double`
  `getCenterY()`
  Gets the value of the `centerY` property.
  `final double`
  `getLength()`
  Gets the value of the `length` property.
  `final double`
  `getRadiusX()`
  Gets the value of the `radiusX` property.
  `final double`
  `getRadiusY()`
  Gets the value of the `radiusY` property.
  `final double`
  `getStartAngle()`
  Gets the value of the `startAngle` property.
  `final ArcType`
  `getType()`
  Gets the value of the `type` property.
  `final DoubleProperty`
  `lengthProperty()`
  Defines the angular extent of the arc in degrees.
  `final DoubleProperty`
  `radiusXProperty()`
  Defines the overall width (horizontal radius) of the full ellipse of which this arc is a partial section.
  `final DoubleProperty`
  `radiusYProperty()`
  Defines the overall height (vertical radius) of the full ellipse of which this arc is a partial section.
  `final void`
  `setCenterX(double value)`
  Sets the value of the `centerX` property.
  `final void`
  `setCenterY(double value)`
  Sets the value of the `centerY` property.
  `final void`
  `setLength(double value)`
  Sets the value of the `length` property.
  `final void`
  `setRadiusX(double value)`
  Sets the value of the `radiusX` property.
  `final void`
  `setRadiusY(double value)`
  Sets the value of the `radiusY` property.
  `final void`
  `setStartAngle(double value)`
  Sets the value of the `startAngle` property.
  `final void`
  `setType(ArcType value)`
  Sets the value of the `type` property.
  `final DoubleProperty`
  `startAngleProperty()`
  Defines the starting angle of the arc in degrees.
  `String`
  `toString()`
  Returns a string representation of this `Arc` object.
  `final ObjectProperty<ArcType>`
  `typeProperty()`
  Defines the closure type for the arc: `ArcType.OPEN`, `ArcType.CHORD`,or `ArcType.ROUND`.

  ### Methods declared in class javafx.scene.shape.Shape

  `fillProperty, getClassCssMetaData, getCssMetaData, getFill, getStroke, getStrokeDashArray, getStrokeDashOffset, getStrokeLineCap, getStrokeLineJoin, getStrokeMiterLimit, getStrokeType, getStrokeWidth, intersect, isSmooth, setFill, setSmooth, setStroke, setStrokeDashOffset, setStrokeLineCap, setStrokeLineJoin, setStrokeMiterLimit, setStrokeType, setStrokeWidth, smoothProperty, strokeDashOffsetProperty, strokeLineCapProperty, strokeLineJoinProperty, strokeMiterLimitProperty, strokeProperty, strokeTypeProperty, strokeWidthProperty, subtract, union`

  ### Methods declared in class javafx.scene.Node

  `accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, executeAccessibleAction, fireEvent, focusedProperty, focusTraversableProperty, focusVisibleProperty, focusWithinProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBaselineOffset, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getContentBias, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInitialFocusTraversable, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isFocusVisible, isFocusWithin, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isResizable, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookup, lookupAll, managedProperty, maxHeight, maxWidth, minHeight, minWidth, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, prefHeight, prefWidth, pressedProperty, pseudoClassStateChanged, queryAccessibleAttribute, relocate, removeEventFilter, removeEventHandler, requestFocus, resize, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods declared in interface javafx.css.Styleable

  `getStyleableNode`

- ## Property Details

  - ### centerX

    public final DoubleProperty centerXProperty
    Defines the X coordinate of the center point of the arc.
    Default value:
      0.0
    See Also:
      - `getCenterX()`
      - `setCenterX(double)`
      - `centerXProperty()`

  - ### centerY

    public final DoubleProperty centerYProperty
    Defines the Y coordinate of the center point of the arc.
    Default value:
      0.0
    See Also:
      - `getCenterY()`
      - `setCenterY(double)`
      - `centerYProperty()`

  - ### radiusX

    public final DoubleProperty radiusXProperty
    Defines the overall width (horizontal radius) of the full ellipse of which this arc is a partial section.
    Default value:
      0.0
    See Also:
      - `getRadiusX()`
      - `setRadiusX(double)`
      - `radiusXProperty()`

  - ### radiusY

    public final DoubleProperty radiusYProperty
    Defines the overall height (vertical radius) of the full ellipse of which this arc is a partial section.
    Default value:
      0.0
    See Also:
      - `getRadiusY()`
      - `setRadiusY(double)`
      - `radiusYProperty()`

  - ### startAngle

    public final DoubleProperty startAngleProperty
    Defines the starting angle of the arc in degrees.
    Default value:
      0.0
    See Also:
      - `getStartAngle()`
      - `setStartAngle(double)`
      - `startAngleProperty()`

  - ### length

    public final DoubleProperty lengthProperty
    Defines the angular extent of the arc in degrees.
    Default value:
      0.0
    See Also:
      - `getLength()`
      - `setLength(double)`
      - `lengthProperty()`

  - ### type

    public final ObjectProperty<ArcType> typeProperty
    Defines the closure type for the arc: `ArcType.OPEN`, `ArcType.CHORD`,or `ArcType.ROUND`.
    Default value:
      OPEN
    See Also:
      - `getType()`
      - `setType(ArcType)`
      - `typeProperty()`

- ## Constructor Details

  - ### Arc

    public Arc()
    Creates an empty instance of Arc.

  - ### Arc

    public Arc(double centerX, double centerY, double radiusX, double radiusY, double startAngle, double length)
    Creates a new instance of Arc.
    Parameters:
      `centerX` - the X coordinate of the center point of the arc
      `centerY` - the Y coordinate of the center point of the arc
      `radiusX` - the overall width (horizontal radius) of the full ellipse of which this arc is a partial section
      `radiusY` - the overall height (vertical radius) of the full ellipse of which this arc is a partial section
      `startAngle` - the starting angle of the arc in degrees
      `length` - the angular extent of the arc in degrees

- ## Method Details

  - ### setCenterX

    public final void setCenterX(double value)
    Sets the value of the `centerX` property.
    Property description:
      Defines the X coordinate of the center point of the arc.
    Default value:
      0.0
    Parameters:
      `value` - the value for the `centerX` property
    See Also:
      - `getCenterX()`
      - `centerXProperty()`

  - ### getCenterX

    public final double getCenterX()
    Gets the value of the `centerX` property.
    Property description:
      Defines the X coordinate of the center point of the arc.
    Default value:
      0.0
    Returns:
      the value of the `centerX` property
    See Also:
      - `setCenterX(double)`
      - `centerXProperty()`

  - ### centerXProperty

    public final DoubleProperty centerXProperty()
    Defines the X coordinate of the center point of the arc.
    Default value:
      0.0
    Returns:
      the `centerX` property
    See Also:
      - `getCenterX()`
      - `setCenterX(double)`

  - ### setCenterY

    public final void setCenterY(double value)
    Sets the value of the `centerY` property.
    Property description:
      Defines the Y coordinate of the center point of the arc.
    Default value:
      0.0
    Parameters:
      `value` - the value for the `centerY` property
    See Also:
      - `getCenterY()`
      - `centerYProperty()`

  - ### getCenterY

    public final double getCenterY()
    Gets the value of the `centerY` property.
    Property description:
      Defines the Y coordinate of the center point of the arc.
    Default value:
      0.0
    Returns:
      the value of the `centerY` property
    See Also:
      - `setCenterY(double)`
      - `centerYProperty()`

  - ### centerYProperty

    public final DoubleProperty centerYProperty()
    Defines the Y coordinate of the center point of the arc.
    Default value:
      0.0
    Returns:
      the `centerY` property
    See Also:
      - `getCenterY()`
      - `setCenterY(double)`

  - ### setRadiusX

    public final void setRadiusX(double value)
    Sets the value of the `radiusX` property.
    Property description:
      Defines the overall width (horizontal radius) of the full ellipse of which this arc is a partial section.
    Default value:
      0.0
    Parameters:
      `value` - the value for the `radiusX` property
    See Also:
      - `getRadiusX()`
      - `radiusXProperty()`

  - ### getRadiusX

    public final double getRadiusX()
    Gets the value of the `radiusX` property.
    Property description:
      Defines the overall width (horizontal radius) of the full ellipse of which this arc is a partial section.
    Default value:
      0.0
    Returns:
      the value of the `radiusX` property
    See Also:
      - `setRadiusX(double)`
      - `radiusXProperty()`

  - ### radiusXProperty

    public final DoubleProperty radiusXProperty()
    Defines the overall width (horizontal radius) of the full ellipse of which this arc is a partial section.
    Default value:
      0.0
    Returns:
      the `radiusX` property
    See Also:
      - `getRadiusX()`
      - `setRadiusX(double)`

  - ### setRadiusY

    public final void setRadiusY(double value)
    Sets the value of the `radiusY` property.
    Property description:
      Defines the overall height (vertical radius) of the full ellipse of which this arc is a partial section.
    Default value:
      0.0
    Parameters:
      `value` - the value for the `radiusY` property
    See Also:
      - `getRadiusY()`
      - `radiusYProperty()`

  - ### getRadiusY

    public final double getRadiusY()
    Gets the value of the `radiusY` property.
    Property description:
      Defines the overall height (vertical radius) of the full ellipse of which this arc is a partial section.
    Default value:
      0.0
    Returns:
      the value of the `radiusY` property
    See Also:
      - `setRadiusY(double)`
      - `radiusYProperty()`

  - ### radiusYProperty

    public final DoubleProperty radiusYProperty()
    Defines the overall height (vertical radius) of the full ellipse of which this arc is a partial section.
    Default value:
      0.0
    Returns:
      the `radiusY` property
    See Also:
      - `getRadiusY()`
      - `setRadiusY(double)`

  - ### setStartAngle

    public final void setStartAngle(double value)
    Sets the value of the `startAngle` property.
    Property description:
      Defines the starting angle of the arc in degrees.
    Default value:
      0.0
    Parameters:
      `value` - the value for the `startAngle` property
    See Also:
      - `getStartAngle()`
      - `startAngleProperty()`

  - ### getStartAngle

    public final double getStartAngle()
    Gets the value of the `startAngle` property.
    Property description:
      Defines the starting angle of the arc in degrees.
    Default value:
      0.0
    Returns:
      the value of the `startAngle` property
    See Also:
      - `setStartAngle(double)`
      - `startAngleProperty()`

  - ### startAngleProperty

    public final DoubleProperty startAngleProperty()
    Defines the starting angle of the arc in degrees.
    Default value:
      0.0
    Returns:
      the `startAngle` property
    See Also:
      - `getStartAngle()`
      - `setStartAngle(double)`

  - ### setLength

    public final void setLength(double value)
    Sets the value of the `length` property.
    Property description:
      Defines the angular extent of the arc in degrees.
    Default value:
      0.0
    Parameters:
      `value` - the value for the `length` property
    See Also:
      - `getLength()`
      - `lengthProperty()`

  - ### getLength

    public final double getLength()
    Gets the value of the `length` property.
    Property description:
      Defines the angular extent of the arc in degrees.
    Default value:
      0.0
    Returns:
      the value of the `length` property
    See Also:
      - `setLength(double)`
      - `lengthProperty()`

  - ### lengthProperty

    public final DoubleProperty lengthProperty()
    Defines the angular extent of the arc in degrees.
    Default value:
      0.0
    Returns:
      the `length` property
    See Also:
      - `getLength()`
      - `setLength(double)`

  - ### setType

    public final void setType(ArcType value)
    Sets the value of the `type` property.
    Property description:
      Defines the closure type for the arc: `ArcType.OPEN`, `ArcType.CHORD`,or `ArcType.ROUND`.
    Default value:
      OPEN
    Parameters:
      `value` - the value for the `type` property
    See Also:
      - `getType()`
      - `typeProperty()`

  - ### getType

    public final ArcType getType()
    Gets the value of the `type` property.
    Property description:
      Defines the closure type for the arc: `ArcType.OPEN`, `ArcType.CHORD`,or `ArcType.ROUND`.
    Default value:
      OPEN
    Returns:
      the value of the `type` property
    See Also:
      - `setType(ArcType)`
      - `typeProperty()`

  - ### typeProperty

    public final ObjectProperty<ArcType> typeProperty()
    Defines the closure type for the arc: `ArcType.OPEN`, `ArcType.CHORD`,or `ArcType.ROUND`.
    Default value:
      OPEN
    Returns:
      the `type` property
    See Also:
      - `getType()`
      - `setType(ArcType)`

  - ### toString

    public String toString()
    Returns a string representation of this `Arc` object.
    Overrides:
      `toString` in class `Node`
    Returns:
      a string representation of this `Arc` object.